
// ==========================================================================
//
// Software written by Boguslaw Cyganek (C) 2008
// Copyrights Pandora Inc. (C) 2008
//
// ==========================================================================
//
// This software is protected by the national and international copyrights. 
// The software is granted only for educational or academic/research purposes   
// and to accompany the book (credited to):
// "AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS"
// by Boguslaw Cyganek & J. Paul Siebert, Wiley, 2008.
// All other commercial and/or non-private applications require a written 
// permission.
// The software is supplied as it is without any guarantees nor responsibility  
// of its use in any application. 
//
// ==========================================================================
//
//  Background: AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS
//  Version:    1.0
//
//  $Workfile: AccumulationTraits_ForFixed.h $
//  $Author  : Boguslaw Cyganek
//  $Created : 2007-05-06 21:32:58
//
//
//  Description:
//				Definitions of different parameters (traits) for fixed point
//				numbers.
//
// ==========================================================================



#ifndef BoxySoft_AccumulationTraits_ForFixed
#define BoxySoft_AccumulationTraits_ForFixed


#include "AccumulationTraits.h"
#include "FixedNumber.h"


///////////////////////////////////////////////////////////////////////////////////////////////////
// Traits for the fixed-point numbers.


template <>
class Accumulation_Trait< FIXED_8_8 >
{
	public: 
		// For FIXED_8_8, accumulator is: FIXED_16_16
		typedef FIXED_16_16 TheAccumulatorType;
		static TheAccumulatorType GetZero( void ) { return FIXED_16_16( 0 ); }
};

template <>
class Accumulation_Trait< FIXED_16_16 >
{
	public: 
		// For FIXED_16_16, accumulator is: FIXED_16_16
		typedef FIXED_16_16 TheAccumulatorType;
		static TheAccumulatorType GetZero( void ) { return FIXED_16_16( 0 ); }
};

template <>
class Accumulation_Trait< FIXED_24_8 >
{
	public: 
		// For FIXED_24_8, accumulator is: FIXED_24_8
		typedef FIXED_24_8 TheAccumulatorType;
		static TheAccumulatorType GetZero( void ) { return FIXED_24_8( 0 ); }
};

template <>
class Accumulation_Trait< FIXED_8_24 >
{
	public: 
		// For FIXED_8_24, accumulator is: FIXED_8_24
		typedef FIXED_8_24 TheAccumulatorType;
		static TheAccumulatorType GetZero( void ) { return FIXED_8_24( 0 ); }
};



#endif BoxySoft_AccumulationTraits_ForFixed




