
// ==========================================================================
//
// Software written by Boguslaw Cyganek (C) 2008
// Copyrights Pandora Inc. (C) 2008
//
// ==========================================================================
//
// This software is protected by the national and international copyrights. 
// The software is granted only for educational or academic/research purposes   
// and to accompany the book (credited to):
// "AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS"
// by Boguslaw Cyganek & J. Paul Siebert, Wiley, 2008.
// All other commercial and/or non-private applications require a written 
// permission.
// The software is supplied as it is without any guarantees nor responsibility  
// of its use in any application. 
//
// ==========================================================================
//
//  Background: AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS
//  Version:    1.0
//
//  $Workfile: ImageDeclarations.h $
//  $Author  : Boguslaw Cyganek
//  $Created : 2007-05-06 21:32:58
//
//
//  Description:
//				This file contains the basic definitions for the library.	
//
// ==========================================================================



#ifndef IMAGE_DECLARATIONS
#define IMAGE_DECLARATIONS


#pragma warning( disable : 4237 )


#include <windows.h>
#include <vector>


using namespace std;


/////////////////////////////////////////////////////////////////////////////////////////////

#define MODERN_COMPILER 0
/*#if defined(_USE_NON_INTEL_COMPILER)
	#define MODERN_COMPILER 0
#else
	#define MODERN_COMPILER 1
#endif 
*/
/////////////////////////////////////////////////////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN


#if _DEBUG
	#define	DEBUGGING 1		 
#else
	#define	DEBUGGING 0		 
#endif

/////////////////////////////////////////////////////////////////////////////////////////////

#if	DEBUGGING

	#define _QUOTE(x) #x
	#define QUOTE(x) _QUOTE(x)

	// on REQUIRE violation exit if not IGNORE from the user
	#define REQUIRE(expr)	{																\
								if( ! (expr) )												\
								{															\
									int m;													\
									if( (m = MessageBox(NULL, 								\
											#expr "\n\n" "IN FILE: " __FILE__				\
											"\n" "IN LINE: " QUOTE(__LINE__),				\
											"HIL\'s REQUIRE doesn\'t hold", 				\
											MB_ICONSTOP | MB_ABORTRETRYIGNORE))==IDABORT )	\
												ExitProcess((UINT)-1);						\
									else													\
										if( m == IDRETRY )									\
											DebugBreak();									\
								}															\
							}																

	#define DEBUG(string) 		MessageBox( NULL, 											\
											#string,										\
											"HIL\'s DEBUG message", 						\
											MB_ICONINFORMATION | MB_OK);					
	
	#define INVARIANT()		if( ! this->Invariant() )										\
							{																\
								int m;														\
								if( (m = MessageBox(NULL, 									\
										"\n" "IN FILE: " __FILE__							\
										"\n" "IN LINE: " QUOTE(__LINE__),					\
										"HIL\'s INVARIANT doesn\'t hold", 					\
										MB_ICONSTOP | MB_ABORTRETRYIGNORE))==IDABORT )		\
											ExitProcess((UINT)-1);							\
								else														\
									if( m == IDRETRY )										\
										DebugBreak();										\
							}
#else	// DEBUGGING

	#define REQUIRE(expr)	;
	#define DEBUG(string)	; 										
	#define INVARIANT()		;

#endif	// DEBUGGING




//////////////////////////////////////////////////////////////////
template < typename T >
void DEBUG_PrintVector( const char * fileName, vector< T > & theVector, bool append = false )
{
#if _DEBUG
	ofstream outFile( fileName, ios::out | ( append == true ? ios::app : 0 ) );
	if( outFile.is_open() )
	{
		copy( theVector.begin(), theVector.end(), ostream_iterator< T >( outFile, ", " ) );
		outFile << endl;
	}
#endif _DEBUG
}
//////////////////////////////////////////////////////////////////


#define NUM_OF_ARRAY_ELEMENTS(a) (sizeof(a)/sizeof(a[0]))


//////////////////////////////////////////////////////////////////




#endif IMAGE_DECLARATIONS


