
// ==========================================================================
//
// Software written by Boguslaw Cyganek (C) 2008
// Copyrights Pandora Inc. (C) 2008
//
// ==========================================================================
//
// This software is protected by the national and international copyrights. 
// The software is granted only for educational or academic/research purposes   
// and to accompany the book (credited to):
// "AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS"
// by Boguslaw Cyganek & J. Paul Siebert, Wiley, 2008.
// All other commercial and/or non-private applications require a written 
// permission.
// The software is supplied as it is without any guarantees nor responsibility  
// of its use in any application. 
//
// ==========================================================================
//
//  Background: AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS
//  Version:    1.0
//
//  $Workfile: ImagePyramids.h $
//  $Author  : Boguslaw Cyganek
//  $Created : 2007-05-06 21:32:58
//
//
//  Description:
//				Definitions of the image pyramids.
//
// ==========================================================================



#ifndef BoxySoft_ImagePyramids
#define BoxySoft_ImagePyramids



#include "HIL_ImageFor.h"
#include "HIL_ImageContainers.h"



using namespace PHIL;




///////////////////////////////////////////////////////////
// This class is an abstract base class for image
// pyramid classes.
///////////////////////////////////////////////////////////
class TImagePyramids
{
	private:

		// Class inherent variables

	protected:

	public:

		// ===================================================
		TImagePyramids( void ) {}				// class default constructor
		virtual ~TImagePyramids() {}				// class virtual destructor
		// ===================================================


		///////////////////////////////////////////////////////////
		// This function creates an image pyramid from the input
		// image.
		///////////////////////////////////////////////////////////
		//		
		// INPUT:
		//			theInputImage - reference to the input image
		//			theOutputPyramid - vector of output images
		//			requiredPyramidLevels - required number of 
		//				the pyramid levels
		//		
		// OUTPUT:
		//			true - if operation successful
		//			false - otherwise
		//		
		// REMARKS:
		//		
		//		
		virtual bool operator () ( const TRealImage & theInputImage, RealImage_Vector & theOutputPyramid, int requiredPyramidLevels ) = 0;

};




#endif BoxySoft_ImagePyramids




