
// ==========================================================================
//
// Software written by Boguslaw Cyganek (C) 2008
// Copyrights Pandora Inc. (C) 2008
//
// ==========================================================================
//
// This software is protected by the national and international copyrights. 
// The software is granted only for educational or academic/research purposes   
// and to accompany the book (credited to):
// "AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS"
// by Boguslaw Cyganek & J. Paul Siebert, Wiley, 2008.
// All other commercial and/or non-private applications require a written 
// permission.
// The software is supplied as it is without any guarantees nor responsibility  
// of its use in any application. 
//
// ==========================================================================
//
//  Background: AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS
//  Version:    1.0
//
//  $Workfile: StereoTest.cpp $
//  $Author  : Boguslaw Cyganek
//  $Created : 2007-05-06 21:32:58
//
//
//  Description:
//				Simple stereo testing.
//
// ==========================================================================



#include "StereoMatcherFor.h"


using namespace PHIL;


void TemplateStereoTest( void )
{
	MonochromeImage left_image( 16, 16, 0 );
	MonochromeImage right_image( 16, 16, 0 );


	typedef Pixel_SAD_Metric< MonochromeImage::PixelType, long >																		SAD_Pixel_Long_Measure;
	typedef TPointOriented_AreaBased_Matcher< MonochromeImage::PixelType, SAD_Pixel_Long_Measure >		PointOriented_SimpleMatchArea_SAD;
	
	
	PointOriented_SimpleMatchArea_SAD		pointMatcher( left_image, right_image, 5, 5, 15, true );
	
	pointMatcher();			// do the matching right now

	// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


	typedef TDisparityOriented_AreaBased_Matcher< MonochromeImage::PixelType, SAD_Pixel_Long_Measure >		DisparityOriented_SAD;
	
	DisparityOriented_SAD		disparityMatcher( left_image, right_image, 5, 5, 15, true );

	disparityMatcher();		// do the matching right now

	// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

}
