
// ==========================================================================
//
// Software written by Boguslaw Cyganek (C) 2008
// Copyrights Pandora Inc. (C) 2008
//
// ==========================================================================
//
// This software is protected by the national and international copyrights. 
// The software is granted only for educational or academic/research purposes   
// and to accompany the book (credited to):
// "AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS"
// by Boguslaw Cyganek & J. Paul Siebert, Wiley, 2008.
// All other commercial and/or non-private applications require a written 
// permission.
// The software is supplied as it is without any guarantees nor responsibility  
// of its use in any application. 
//
// ==========================================================================
//
//  Background: AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS
//  Version:    1.0
//
//  $Workfile: ImageContainers.h $
//  $Author  : Boguslaw Cyganek
//  $Created : 2007-05-06 21:32:58
//
//
//  Description:
//				Definitions of the image vectors, i.e. data structures
//				to store and process sequences of images.
//
// ==========================================================================



#ifndef BoxySoft_HIL_ImageContainers
#define BoxySoft_HIL_ImageContainers


#include <memory>
#include "HIL_ImageFor.h"
#include "HIL_MultiChannelImageFor.h"



namespace PHIL	
{

	////////////////////////////////////////////////////////////////////////////////////////

	typedef std::vector< TRealImage >			RealImage_Vector;
	typedef std::vector< MonochromeImage >		MonochromeImage_Vector;
	typedef std::vector< NI_Color_3x8_Image >	NI_Color_3x8_Image_Vector;

	// Here you can add your own type ...

	////////////////////////////////////////////////////////////////////////////////////////



}	// end of the PHIL namespace


#endif BoxySoft_HIL_ImageContainers




