
// ==========================================================================
//
// Software written by Boguslaw Cyganek (C) 2008
// Copyrights Pandora Inc. (C) 2008
//
// ==========================================================================
//
// This software is protected by the national and international copyrights. 
// The software is granted only for educational or academic/research purposes   
// and to accompany the book (credited to):
// "AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS"
// by Boguslaw Cyganek & J. Paul Siebert, Wiley, 2008.
// All other commercial and/or non-private applications require a written 
// permission.
// The software is supplied as it is without any guarantees nor responsibility  
// of its use in any application. 
//
// ==========================================================================
//
//  Background: AN INTRODUCTION TO 3D COMPUTER VISION TECHNIQUES AND ALGORITHMS
//  Version:    1.0
//
//  $Workfile: HIL_ImageForFixed.h $
//  $Author  : Boguslaw Cyganek
//  $Created : 2007-05-06 21:32:58
//
//
//  Description:
//				Definitions of containers operating with data in fixed point
//				representation.
//
// ==========================================================================




#ifndef BoxySoft_HIL_ImageForFixed
#define BoxySoft_HIL_ImageForFixed


#include "HIL_ImageFor.h"
#include "HIL_MultiChannelImageFor.h"
#include "FixedNumber.h"



namespace PHIL		
{


// ==========================================================================

///////////////////////////////////////////////////////////////////////////

typedef vector< FIXED_8_8 >				FIXED_8_VEC;
typedef vector< FIXED_16_16 >			FIXED_16_VEC;

///////////////////////////////////////////////////////////////////////////

typedef TImageFor< FIXED_8_8 >				ImageForFixed_8_8;
typedef TImageFor< FIXED_16_16 >			ImageForFixed_16_16;
typedef TImageFor< FIXED_24_8 >				ImageForFixed_24_8;
typedef TImageFor< FIXED_8_24 >				ImageForFixed_8_24;

///////////////////////////////////////////////////////////////////////////

typedef	MMultiPixelFor< FIXED_8_8 >				Color_3xFi8_8_Pixel;	
typedef	TMultiChannelImageFor< FIXED_8_8 >		NI_Color_3xFi8_8_Image;		// non-interlaced color image

typedef	MMultiPixelFor< FIXED_16_16 >			Color_3xFi16_16_Pixel;	
typedef	TMultiChannelImageFor< FIXED_16_16 >	NI_Color_3xFi16_16_Image;	// non-interlaced color image


///////////////////////////////////////////////////////////////////////////


// ==========================================================================

}	// end of the PHIL namespace

// ==========================================================================


#endif BoxySoft_HIL_ImageForFixed




